#pragma once
#include "LinuxDevI2CRw.h"
#include "CpDeviceComBase.h"
// max len 256: data 255 + subAddress :1  
const WORD US_I2C_PAGELENGTH = 128;

class CDevI2C :public CCpDeviceComBase
{
public:
    CDevI2C(void);
    virtual ~CDevI2C(void);

    STRUCT_ENUM_ERROR_TYPE InitialDev();
    STRUCT_ENUM_ERROR_TYPE ReleaseDev();
    STRUCT_ENUM_COMM_ID GetCommID();
    void GetCommName(TCHAR *pcName, WORD usLength);
    WORD GetI2CPageLength();
    STRUCT_ENUM_ERROR_TYPE I2CWrite(BYTE ucSlave, BYTE ucSub, WORD usLength, const BYTE* pucBuf);
    STRUCT_ENUM_ERROR_TYPE I2CRead(BYTE ucSlave, BYTE ucSub, WORD usLength, BYTE* pucBuf);
       
};
