#include <stdio.h>
#include <string.h>
#include <iostream>
#include <vector>
#include <unistd.h>
#include <dirent.h>
#include <dlfcn.h>
#include "../Comm_PlugIn/Comm_PlugIn_Export/CPComm_PlugIn_Define/CpCommPlugInExport.h"
#include "../Tool_Common/RsCommon/RegDef.h"
#include "Comm_Export/CpCommInclude.h"
#include "Comm.h"
#include "../Tool_Common/CpRsFuncBase.h"

extern VECTORDEVICEINFO g_vectDeviceInfo;


STRUCT_ENUM_ERROR_TYPE Initiallize()
{
    g_vectDeviceInfo.clear();
    STRUCT_DEVICE_INFO stDeviceInfo;
    struct dirent *dp;
    DIR *dfd;
    TCHAR dir_path[_MAX_PATH] = "Comm/";
    TCHAR dll_path[_MAX_PATH] = "";
    //string dir;

    sprintf(dir_path, "%s%s", GetCurrentProcessDir().c_str(), "Comm/");
    dfd = opendir(dir_path);
    if(dfd  == NULL)
    {
        printf("Opend dir failed! %s,", dir_path);
        return _ERROR_COMM_LOADDLL_FAIL;
    }
    dp = readdir(dfd);

    while(dp != NULL)
    {
        if((strcmp(dp->d_name, ".") == 0) || (strcmp(dp->d_name, "..") == 0))
        {
            dp = readdir(dfd);
            continue;
        }
        int nLen = strlen(dp->d_name);

        if(strcmp((dp->d_name + (nLen - 3)), ".so") == 0)
        {
            sprintf(dll_path, "%s%s", dir_path, dp->d_name);

            if(rsdLoadDeviceDllFile(dll_path))
            {   
                stDeviceInfo.strDllFile = dll_path;
                stDeviceInfo.enumCommID = rsdGetCommID();
                rsdGetCommName(stDeviceInfo.carrCommName, _MAX_PATH);
                g_vectDeviceInfo.push_back(stDeviceInfo);
                rsdFreeDeviceDllFile();
            }
            
        }
        dp = readdir(dfd);
    }

    closedir(dfd);
    return _ERROR_SUCCESS;
}

