#pragma once
#ifndef _CP_DB_BASE_H
#define  _CP_DB_BASE_H
#ifndef UNICODE
#include "../../Tool_Common/RsDataType.h"
#endif
#ifndef SAFELY_DELETE
#define SAFELY_DELETE(x)   if(x != NULL){delete [] x; x = NULL;}
#endif

#include <fstream>

CONST DWORD UL_CP_DB_MAGIC = 0x99552277;
CONST DWORD UL_CP_MAX_BUFFER_LENGTH = 100000;

typedef struct
{
    DWORD ulMagic;
    DWORD ulVersion;
    DWORD ulFileLength;
}STRUCT_CP_DB_FILE_HEADER;

class CCpDbBase
{
public:
    CCpDbBase();
    ~CCpDbBase();

    BOOL GetDBVersion(std::string strFile, DWORD& ulVer);
    BOOL GetDBHeader(LPBYTE pucBuffer, STRUCT_CP_DB_FILE_HEADER& stHeader);

protected:
    BOOL CopyStringToBuff(std::string strSrc, BYTE*& pucStrbuff, DWORD& ulStrBuffIndex, DWORD& ulStrBuffLen);
    BOOL CopyStructToBuff(void* pSrc, DWORD ulSrcSize, BYTE*& pucDes, DWORD& ulBuffIndex, DWORD& ulBuffLen);
    BOOL CopyBuffToString(BYTE *pucStrBuf, DWORD ulOffset, std::string& strRet);
};


#endif
